// gpu/ipc/common/device_perf_info.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef GPU_IPC_COMMON_DEVICE_PERF_INFO_MOJOM_SHARED_H_
#define GPU_IPC_COMMON_DEVICE_PERF_INFO_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "gpu/ipc/common/device_perf_info.mojom-shared-internal.h"







namespace gpu {
namespace mojom {
class DevicePerfInfoDataView;



}  // namespace mojom
}  // namespace gpu

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::gpu::mojom::DevicePerfInfoDataView> {
  using Data = ::gpu::mojom::internal::DevicePerfInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace gpu {
namespace mojom {


enum class Direct3DFeatureLevel : int32_t {
  
  k1_0_Core = 0,
  
  k9_1 = 1,
  
  k9_2 = 2,
  
  k9_3 = 3,
  
  k10_0 = 4,
  
  k10_1 = 5,
  
  k11_0 = 6,
  
  k11_1 = 7,
  
  k12_0 = 8,
  
  k12_1 = 9,
  kMinValue = 0,
  kMaxValue = 9,
};

 std::ostream& operator<<(std::ostream& os, Direct3DFeatureLevel value);
inline bool IsKnownEnumValue(Direct3DFeatureLevel value) {
  return internal::Direct3DFeatureLevel_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class HasDiscreteGpu : int32_t {
  
  kUnknown = 0,
  
  kNo = 1,
  
  kYes = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, HasDiscreteGpu value);
inline bool IsKnownEnumValue(HasDiscreteGpu value) {
  return internal::HasDiscreteGpu_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class DevicePerfInfoDataView {
 public:
  DevicePerfInfoDataView() {}

  DevicePerfInfoDataView(
      internal::DevicePerfInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t total_physical_memory_mb() const {
    return data_->total_physical_memory_mb;
  }
  uint32_t total_disk_space_mb() const {
    return data_->total_disk_space_mb;
  }
  uint32_t hardware_concurrency() const {
    return data_->hardware_concurrency;
  }
 private:
  internal::DevicePerfInfo_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace gpu

namespace std {

template <>
struct hash<::gpu::mojom::Direct3DFeatureLevel>
    : public mojo::internal::EnumHashImpl<::gpu::mojom::Direct3DFeatureLevel> {};

template <>
struct hash<::gpu::mojom::HasDiscreteGpu>
    : public mojo::internal::EnumHashImpl<::gpu::mojom::HasDiscreteGpu> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::gpu::mojom::Direct3DFeatureLevel, ::gpu::mojom::Direct3DFeatureLevel> {
  static ::gpu::mojom::Direct3DFeatureLevel ToMojom(::gpu::mojom::Direct3DFeatureLevel input) { return input; }
  static bool FromMojom(::gpu::mojom::Direct3DFeatureLevel input, ::gpu::mojom::Direct3DFeatureLevel* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gpu::mojom::Direct3DFeatureLevel, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::gpu::mojom::Direct3DFeatureLevel, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::gpu::mojom::Direct3DFeatureLevel>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::gpu::mojom::HasDiscreteGpu, ::gpu::mojom::HasDiscreteGpu> {
  static ::gpu::mojom::HasDiscreteGpu ToMojom(::gpu::mojom::HasDiscreteGpu input) { return input; }
  static bool FromMojom(::gpu::mojom::HasDiscreteGpu input, ::gpu::mojom::HasDiscreteGpu* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gpu::mojom::HasDiscreteGpu, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::gpu::mojom::HasDiscreteGpu, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::gpu::mojom::HasDiscreteGpu>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::gpu::mojom::DevicePerfInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::gpu::mojom::DevicePerfInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::gpu::mojom::internal::DevicePerfInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->total_physical_memory_mb = Traits::total_physical_memory_mb(input);
    (*output)->total_disk_space_mb = Traits::total_disk_space_mb(input);
    (*output)->hardware_concurrency = Traits::hardware_concurrency(input);
  }

  static bool Deserialize(::gpu::mojom::internal::DevicePerfInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::gpu::mojom::DevicePerfInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace gpu {
namespace mojom {




}  // namespace mojom
}  // namespace gpu

#endif  // GPU_IPC_COMMON_DEVICE_PERF_INFO_MOJOM_SHARED_H_