// services/viz/privileged/mojom/compositing/layered_window_updater.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_MOJOM_COMPOSITING_LAYERED_WINDOW_UPDATER_MOJOM_H_
#define SERVICES_VIZ_PRIVILEGED_MOJOM_COMPOSITING_LAYERED_WINDOW_UPDATER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/viz/privileged/mojom/compositing/layered_window_updater.mojom-shared.h"
#include "services/viz/privileged/mojom/compositing/layered_window_updater.mojom-forward.h"
#include "mojo/public/mojom/base/shared_memory.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"





// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace viz {
namespace mojom {

class LayeredWindowUpdaterProxy;

template <typename ImplRefTraits>
class LayeredWindowUpdaterStub;

class LayeredWindowUpdaterRequestValidator;
class LayeredWindowUpdaterResponseValidator;


class  LayeredWindowUpdater
    : public LayeredWindowUpdaterInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = LayeredWindowUpdaterInterfaceBase;
  using Proxy_ = LayeredWindowUpdaterProxy;

  template <typename ImplRefTraits>
  using Stub_ = LayeredWindowUpdaterStub<ImplRefTraits>;

  using RequestValidator_ = LayeredWindowUpdaterRequestValidator;
  using ResponseValidator_ = LayeredWindowUpdaterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnAllocatedSharedMemoryMinVersion = 0,
    kDrawMinVersion = 0,
  };
  virtual ~LayeredWindowUpdater() {}

  
  virtual void OnAllocatedSharedMemory(const ::gfx::Size& pixel_size, ::base::UnsafeSharedMemoryRegion region) = 0;


  using DrawCallback = base::OnceCallback<void()>;
  
  virtual void Draw(DrawCallback callback) = 0;
};



class  LayeredWindowUpdaterProxy
    : public LayeredWindowUpdater {
 public:
  using InterfaceType = LayeredWindowUpdater;

  explicit LayeredWindowUpdaterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnAllocatedSharedMemory(const ::gfx::Size& pixel_size, ::base::UnsafeSharedMemoryRegion region) final;
  
  void Draw(DrawCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  LayeredWindowUpdaterStubDispatch {
 public:
  static bool Accept(LayeredWindowUpdater* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LayeredWindowUpdater* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LayeredWindowUpdater>>
class LayeredWindowUpdaterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LayeredWindowUpdaterStub() {}
  ~LayeredWindowUpdaterStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LayeredWindowUpdaterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LayeredWindowUpdaterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LayeredWindowUpdaterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LayeredWindowUpdaterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace viz

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_VIZ_PRIVILEGED_MOJOM_COMPOSITING_LAYERED_WINDOW_UPDATER_MOJOM_H_