// third_party/blink/public/mojom/favicon/favicon_url.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FAVICON_FAVICON_URL_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FAVICON_FAVICON_URL_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/favicon/favicon_url.mojom-shared.h"
#include "third_party/blink/public/mojom/favicon/favicon_url.mojom-blink-forward.h"
#include "url/mojom/url.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/renderer/platform/platform_export.h"




namespace WTF {
struct blink_mojom_internal_FaviconIconType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::FaviconIconType& value) {
    using utype = std::underlying_type<::blink::mojom::FaviconIconType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::FaviconIconType& left, const ::blink::mojom::FaviconIconType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::blink::mojom::FaviconIconType>
    : public GenericHashTraits<::blink::mojom::FaviconIconType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::FaviconIconType& value) {
    return value == static_cast<::blink::mojom::FaviconIconType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::FaviconIconType& slot, bool) {
    slot = static_cast<::blink::mojom::FaviconIconType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::FaviconIconType& value) {
    return value == static_cast<::blink::mojom::FaviconIconType>(-1000001);
  }
};
}  // namespace WTF

// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {
namespace blink {








class PLATFORM_EXPORT FaviconURL {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FaviconURL, T>::value>;
  using DataView = FaviconURLDataView;
  using Data_ = internal::FaviconURL_Data;

  template <typename... Args>
  static FaviconURLPtr New(Args&&... args) {
    return FaviconURLPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FaviconURLPtr From(const U& u) {
    return mojo::TypeConverter<FaviconURLPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FaviconURL>::Convert(*this);
  }


  FaviconURL();

  FaviconURL(
      const ::blink::KURL& icon_url,
      FaviconIconType icon_type,
      WTF::Vector<::gfx::Size> icon_sizes);

  ~FaviconURL();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FaviconURLPtr>
  FaviconURLPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FaviconURL::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FaviconURL::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FaviconURL::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FaviconURL_UnserializedMessageContext<
            UserType, FaviconURL::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FaviconURL::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FaviconURL::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FaviconURL_UnserializedMessageContext<
            UserType, FaviconURL::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FaviconURL::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::blink::KURL icon_url;
  
  FaviconIconType icon_type;
  
  WTF::Vector<::gfx::Size> icon_sizes;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FaviconURL::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FaviconURL::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FaviconURL::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FaviconURL::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FaviconURLPtr FaviconURL::Clone() const {
  return New(
      mojo::Clone(icon_url),
      mojo::Clone(icon_type),
      mojo::Clone(icon_sizes)
  );
}

template <typename T, FaviconURL::EnableIfSame<T>*>
bool FaviconURL::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->icon_url, other_struct.icon_url))
    return false;
  if (!mojo::Equals(this->icon_type, other_struct.icon_type))
    return false;
  if (!mojo::Equals(this->icon_sizes, other_struct.icon_sizes))
    return false;
  return true;
}

template <typename T, FaviconURL::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.icon_url, rhs.icon_url))
    return true;
  if (std::less<>{}(rhs.icon_url, lhs.icon_url))
    return false;
  if (std::less<>{}(lhs.icon_type, rhs.icon_type))
    return true;
  if (std::less<>{}(rhs.icon_type, lhs.icon_type))
    return false;
  if (std::less<>{}(lhs.icon_sizes, rhs.icon_sizes))
    return true;
  if (std::less<>{}(rhs.icon_sizes, lhs.icon_sizes))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::FaviconURL::DataView,
                                         ::blink::mojom::blink::FaviconURLPtr> {
  static bool IsNull(const ::blink::mojom::blink::FaviconURLPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::FaviconURLPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::FaviconURL::icon_url)& icon_url(
      const ::blink::mojom::blink::FaviconURLPtr& input) {
    return input->icon_url;
  }

  static decltype(::blink::mojom::blink::FaviconURL::icon_type) icon_type(
      const ::blink::mojom::blink::FaviconURLPtr& input) {
    return input->icon_type;
  }

  static const decltype(::blink::mojom::blink::FaviconURL::icon_sizes)& icon_sizes(
      const ::blink::mojom::blink::FaviconURLPtr& input) {
    return input->icon_sizes;
  }

  static bool Read(::blink::mojom::blink::FaviconURL::DataView input, ::blink::mojom::blink::FaviconURLPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FAVICON_FAVICON_URL_MOJOM_BLINK_H_