// third_party/blink/public/mojom/link_to_text/link_to_text.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LINK_TO_TEXT_LINK_TO_TEXT_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LINK_TO_TEXT_LINK_TO_TEXT_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/link_to_text/link_to_text.mojom-shared.h"
#include "third_party/blink/public/mojom/link_to_text/link_to_text.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {

class TextFragmentSelectorProducerProxy;

template <typename ImplRefTraits>
class TextFragmentSelectorProducerStub;

class TextFragmentSelectorProducerRequestValidator;
class TextFragmentSelectorProducerResponseValidator;


class BLINK_COMMON_EXPORT TextFragmentSelectorProducer
    : public TextFragmentSelectorProducerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = TextFragmentSelectorProducerInterfaceBase;
  using Proxy_ = TextFragmentSelectorProducerProxy;

  template <typename ImplRefTraits>
  using Stub_ = TextFragmentSelectorProducerStub<ImplRefTraits>;

  using RequestValidator_ = TextFragmentSelectorProducerRequestValidator;
  using ResponseValidator_ = TextFragmentSelectorProducerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGenerateSelectorMinVersion = 0,
  };
  virtual ~TextFragmentSelectorProducer() {}


  using GenerateSelectorCallback = base::OnceCallback<void(const std::string&)>;
  
  virtual void GenerateSelector(GenerateSelectorCallback callback) = 0;
};



class BLINK_COMMON_EXPORT TextFragmentSelectorProducerProxy
    : public TextFragmentSelectorProducer {
 public:
  using InterfaceType = TextFragmentSelectorProducer;

  explicit TextFragmentSelectorProducerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GenerateSelector(GenerateSelectorCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT TextFragmentSelectorProducerStubDispatch {
 public:
  static bool Accept(TextFragmentSelectorProducer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TextFragmentSelectorProducer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TextFragmentSelectorProducer>>
class TextFragmentSelectorProducerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TextFragmentSelectorProducerStub() {}
  ~TextFragmentSelectorProducerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextFragmentSelectorProducerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextFragmentSelectorProducerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT TextFragmentSelectorProducerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT TextFragmentSelectorProducerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LINK_TO_TEXT_LINK_TO_TEXT_MOJOM_H_