// third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom-params-data.h"
#include "third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/user_agent/user_agent_metadata.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_USER_AGENT_USER_AGENT_METADATA_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_USER_AGENT_USER_AGENT_METADATA_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
UserAgentBrandVersion::UserAgentBrandVersion()
    : brand(),
      major_version() {}

UserAgentBrandVersion::UserAgentBrandVersion(
    const std::string& brand_in,
    const std::string& major_version_in)
    : brand(std::move(brand_in)),
      major_version(std::move(major_version_in)) {}

UserAgentBrandVersion::~UserAgentBrandVersion() = default;

void UserAgentBrandVersion::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("brand", this->brand);
  value->SetString("major_version", this->major_version);
}

bool UserAgentBrandVersion::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
UserAgentMetadata::UserAgentMetadata()
    : brand_version_list(),
      full_version(),
      platform(),
      platform_version(),
      architecture(),
      model(),
      mobile() {}

UserAgentMetadata::UserAgentMetadata(
    std::vector<::blink::UserAgentBrandVersion> brand_version_list_in,
    const std::string& full_version_in,
    const std::string& platform_in,
    const std::string& platform_version_in,
    const std::string& architecture_in,
    const std::string& model_in,
    bool mobile_in)
    : brand_version_list(std::move(brand_version_list_in)),
      full_version(std::move(full_version_in)),
      platform(std::move(platform_in)),
      platform_version(std::move(platform_version_in)),
      architecture(std::move(architecture_in)),
      model(std::move(model_in)),
      mobile(std::move(mobile_in)) {}

UserAgentMetadata::~UserAgentMetadata() = default;

void UserAgentMetadata::AsValueInto(base::trace_event::TracedValue* value) const {
  value->BeginArray("brand_version_list");
  for (const auto& item0 : this->brand_version_list) {
    value->AppendString(base::trace_event::ValueToString(item0, "<value of type const ::blink::UserAgentBrandVersion&>"));
  }
  value->EndArray();
  value->SetString("full_version", this->full_version);
  value->SetString("platform", this->platform);
  value->SetString("platform_version", this->platform_version);
  value->SetString("architecture", this->architecture);
  value->SetString("model", this->model);
  value->SetBoolean("mobile", this->mobile);
}

bool UserAgentMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
UserAgentOverride::UserAgentOverride()
    : ua_string_override(),
      ua_metadata_override() {}

UserAgentOverride::UserAgentOverride(
    const std::string& ua_string_override_in,
    const base::Optional<::blink::UserAgentMetadata>& ua_metadata_override_in)
    : ua_string_override(std::move(ua_string_override_in)),
      ua_metadata_override(std::move(ua_metadata_override_in)) {}

UserAgentOverride::~UserAgentOverride() = default;

void UserAgentOverride::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("ua_string_override", this->ua_string_override);
  value->SetString("ua_metadata_override", base::trace_event::ValueToString(this->ua_metadata_override, "<value of type const base::Optional<::blink::UserAgentMetadata>&>"));
}

bool UserAgentOverride::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::UserAgentBrandVersion::DataView, ::blink::mojom::UserAgentBrandVersionPtr>::Read(
    ::blink::mojom::UserAgentBrandVersion::DataView input,
    ::blink::mojom::UserAgentBrandVersionPtr* output) {
  bool success = true;
  ::blink::mojom::UserAgentBrandVersionPtr result(::blink::mojom::UserAgentBrandVersion::New());
  
      if (success && !input.ReadBrand(&result->brand))
        success = false;
      if (success && !input.ReadMajorVersion(&result->major_version))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::UserAgentMetadata::DataView, ::blink::mojom::UserAgentMetadataPtr>::Read(
    ::blink::mojom::UserAgentMetadata::DataView input,
    ::blink::mojom::UserAgentMetadataPtr* output) {
  bool success = true;
  ::blink::mojom::UserAgentMetadataPtr result(::blink::mojom::UserAgentMetadata::New());
  
      if (success && !input.ReadBrandVersionList(&result->brand_version_list))
        success = false;
      if (success && !input.ReadFullVersion(&result->full_version))
        success = false;
      if (success && !input.ReadPlatform(&result->platform))
        success = false;
      if (success && !input.ReadPlatformVersion(&result->platform_version))
        success = false;
      if (success && !input.ReadArchitecture(&result->architecture))
        success = false;
      if (success && !input.ReadModel(&result->model))
        success = false;
      if (success)
        result->mobile = input.mobile();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::UserAgentOverride::DataView, ::blink::mojom::UserAgentOverridePtr>::Read(
    ::blink::mojom::UserAgentOverride::DataView input,
    ::blink::mojom::UserAgentOverridePtr* output) {
  bool success = true;
  ::blink::mojom::UserAgentOverridePtr result(::blink::mojom::UserAgentOverride::New());
  
      if (success && !input.ReadUaStringOverride(&result->ua_string_override))
        success = false;
      if (success && !input.ReadUaMetadataOverride(&result->ua_metadata_override))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif